#include "RingBuffer.h"
#define RingBufferLength 32
    int _buffer[32];  //storage area for bytes when read by the interrupt.
     int _bufferHead = 0; //ring buffer head
    int _bufferTail = 0; // ring buffer tail

 
 RingBuffer::RingBuffer()
{
       _bufferHead = 0; //ring buffer head
    _bufferTail = 0; // ring buffer tail
}


int RingBuffer::bufferLength()
{
if(_bufferHead==_bufferTail)
  return(0);
  else
  if(_bufferTail<_bufferHead)
    return(RingBufferLength-_bufferHead+_bufferTail);
  else
    return(_bufferTail-_bufferHead);
  
}
    void RingBuffer::enqueue(byte inByte)
    {
    _buffer[_bufferTail]=inByte;
    _bufferTail++;
    
    if (_bufferTail>= RingBufferLength)  
      _bufferTail-=RingBufferLength;
     }


     
    byte RingBuffer::dequeue()
    {
    byte tbyte = _buffer[_bufferHead];
    _bufferHead++;
    if (_bufferHead>= RingBufferLength)  
      _bufferHead-=RingBufferLength;
     return tbyte;
     }
  
    void RingBuffer::clearBuffer()
    {
      _bufferTail = 0;
      _bufferHead = 0;
    }

