#include <Arduino.h>
#ifndef byte
#define byte uint8_t
#endif
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif


class RingBuffer
{
  public:
  RingBuffer();
    int bufferLength();
    void enqueue(byte inByte);
    byte dequeue();
    void clearBuffer();
    
  private:
    int _buffer[32];  //storage area for bytes when read by the interrupt.
     int _bufferHead; //ring buffer head
    int _bufferTail; // ring buffer tail


};
