
#ifndef ISO9141_H
#define ISO9141_H
#endif
#ifndef byte
#define byte uint8_t
#endif

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#define initAddress 0x33 //used for 5 baud init
void serialStart(int baudrate, int _ISO_rxPin, int _ISO_txPin);
void enableRxInt();
void readIncomingBit();
void setISO_Headers();
bool ISO_isAlive();
void ISO_initialize();
bool ISO_dataAvailable();
bool ISO_validateChecksum(byte * message,int messageLength);
bool ISO_validateTarget(byte * message,int messageLength,byte * messageHeader);
bool respondMSG();
void ISO_loop();
void ISO_update(double currentTime);
